﻿Imports System.Windows.Threading
Imports System.Windows.Media.Effects
Class MainWindow

    Dim MyTimer As DispatcherTimer

    Private Sub AdjustShapes()

        ' 円をそろえる
        For Each c As FrameworkElement In Canvas1.Children
            If TypeOf c Is Ellipse Then
                Canvas.SetLeft(c, (Canvas1.ActualWidth - c.Width) / 2)
                Canvas.SetTop(c, (Canvas1.ActualHeight - c.Height) / 2)
            End If

            If TypeOf c Is Rectangle Then
                Canvas.SetLeft(c, (Canvas1.ActualWidth - c.Width) / 2)
            End If
        Next

        ' 目盛りを作成する
        For i As Integer = 0 To 11
            Dim r As Rectangle = New Rectangle()
            r.Width = 4
            r.Height = 16
            r.Fill = New SolidColorBrush(Color.FromRgb(80, 80, 80))
            Canvas.SetTop(r, 40)
            Canvas.SetLeft(r, (Canvas1.ActualWidth - r.Width) / 2)
            Canvas1.Children.Add(r)
            Dim rotate As RotateTransform = New RotateTransform(30 * i, r.Width / 2, (Canvas1.ActualHeight / 2 - Canvas.GetTop(r)))
            r.RenderTransform = rotate
            r.RadiusX = 2
            r.RadiusY = 2
        Next

    End Sub

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        AdjustShapes()
        ' タイマーを作成
        MyTimer = New DispatcherTimer()
        MyTimer.Interval = New TimeSpan(0, 0, 0, 0, 60)
        AddHandler MyTimer.Tick, AddressOf Timer_Tick
        MyTimer.Start()

    End Sub

    Sub LineRotate(MyLine As Line, s As Double, d1 As Double, d2 As Double)

        Dim cx As Double = Canvas1.ActualWidth / 2
        Dim cy As Double = Canvas1.ActualHeight / 2
        Dim r As Double = (s + 270) * Math.PI / 180

        ' 線を角度に従って回転させる
        MyLine.X1 = d1 * Math.Cos(r) + cx
        MyLine.X2 = d2 * Math.Cos(r) + cx
        MyLine.Y1 = d1 * Math.Sin(r) + cy
        MyLine.Y2 = d2 * Math.Sin(r) + cy

    End Sub

    Sub Timer_Tick(sender As Object, e As EventArgs)

        Dim d As DateTime = DateTime.Now

        ' 秒
        LineRotate(Line1, (d.Second + d.Millisecond / 1000) * 6, 100, -10)

        ' 分
        LineRotate(Line2, (d.Minute + d.Second / 60) * 6, 80, -3)

        ' 時
        LineRotate(Line3, ((d.Hour Mod 12) + d.Minute / 60) * 30, 50, -3)

    End Sub
End Class
