﻿Class MainWindow 

    Delegate Function InterestFunc(p As Decimal, r As Decimal,
                                   y As Integer) As Decimal

    Private Sub SimpleButton_Click(sender As Object, e As RoutedEventArgs) Handles SimpleButton.Click

        Dim f = Function(p As Decimal, r As Decimal,
                         y As Integer) p * (1 + y * r)
        Interest(f)

    End Sub

    Private Sub CompoundButton_Click(sender As Object, e As RoutedEventArgs) Handles CompoundButton.Click

        Dim f = Function(p As Decimal, r As Decimal,
                         y As Integer) p * Math.Pow((1 + r / 2), 2 * y)
        Interest(f)

    End Sub

    Sub Interest(f As InterestFunc)

        Dim p, r, Total As Decimal
        Dim y As Integer

        If Decimal.TryParse(PrincipalTextBox.Text, p) And
            Decimal.TryParse(RateTextBox.Text, r) And
            Integer.TryParse(YearTextBox.Text, y) Then
            r = r / 100
            Total = Math.Floor(f(p, r, y))
            MessageLabel.Content = "元利合計は " & Total & " です"
        Else
            MessageLabel.Content = "数値を入力してください"
        End If

    End Sub
End Class
