﻿Imports System.IO
Imports System.ComponentModel
Class MainWindow

    Dim MyBackgroundWorker As BackgroundWorker

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        MyBackgroundWorker = New BackgroundWorker()
        MyBackgroundWorker.WorkerReportsProgress = True
        MyBackgroundWorker.WorkerSupportsCancellation = True
        AddHandler MyBackgroundWorker.DoWork,
            AddressOf BackgroundWorker_DoWork
        AddHandler MyBackgroundWorker.RunWorkerCompleted,
            AddressOf BackgroundWorker_RunWorkerCompleted
        AddHandler MyBackgroundWorker.ProgressChanged,
            AddressOf BackgroundWorker_ProgressChanged

    End Sub

    Private Sub BackgroundWorker_DoWork(sender As Object, e As DoWorkEventArgs)

        For i As Integer = 1 To 5
            If WriteFile(Path.Combine(Path.GetDirectoryName(
                                   Application.ResourceAssembly.Location),
                                   "Alphabet" & i)) Then
                e.Cancel = True
                Exit For
            End If
        Next

    End Sub

    Private Sub BackgroundWorker_RunWorkerCompleted(sender As Object, e As RunWorkerCompletedEventArgs)

        If e.Cancelled Then
            MessageLabel.Content = "処理がキャンセルされました"
        ElseIf e.Error Is Nothing Then
            MessageLabel.Content = "処理が終わりました"
        Else
            MessageBox.Show(e.Error.Message, Me.Title,
                MessageBoxButton.OK, MessageBoxImage.Error)
        End If

        GoButton.IsEnabled = True

    End Sub

    Function WriteFile(fn As String) As Boolean

        Dim r As Random = New Random()
        Dim sw As StreamWriter = New StreamWriter(fn)
        Dim CancelState As Boolean = False

        Dim s As String =
            "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
        For i As Integer = 1 To 104857600
            If i Mod 1048576 = 0 Then
                MyBackgroundWorker.ReportProgress(i / 1048576,
                    Path.GetFileName(fn))
            End If
            If MyBackgroundWorker.CancellationPending Then
                CancelState = True
                Exit For
            End If
            sw.Write(s.Chars(r.Next(s.Length)))
        Next
        sw.Close()
        Return CancelState

    End Function

    Private Sub BackgroundWorker_ProgressChanged(sender As Object, e As ProgressChangedEventArgs)

        MessageLabel.Content = e.UserState & "を処理中　" &
            e.ProgressPercentage & "% 完了"

    End Sub

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        GoButton.IsEnabled = False
        MyBackgroundWorker.RunWorkerAsync()

    End Sub

    Private Sub CancelButton_Click(sender As Object, e As RoutedEventArgs) Handles CancelButton.Click
        MyBackgroundWorker.CancelAsync()
    End Sub
End Class
