﻿Imports System.IO
Imports System.Threading
Class MainWindow

    Dim MyTokenSource As CancellationTokenSource

    Private Async Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click

        GoButton.IsEnabled = False
        MyTokenSource = New CancellationTokenSource()

        Dim MyProgress As Progress(Of String) =
            New Progress(Of String)(AddressOf DisplayProgress)

        Dim ProcessTime As TimeSpan =
            Await WriteFileAsync(5, MyProgress)

        Dim TotalSecond As Integer =
            Math.Floor(ProcessTime.TotalSeconds())

        If TotalSecond < 0 Then
            MessageLabel.Content = Math.Abs(TotalSecond) &
                "秒で処理が中止されました"
        Else
            MessageLabel.Content = TotalSecond & "秒で処理が終わりました"
        End If
        GoButton.IsEnabled = True

    End Sub

    Sub DisplayProgress(s As String)
        MessageLabel.Content = s
    End Sub

    Private Async Function WriteFileAsync(Count As Integer, progress As IProgress(Of String)) As Task(Of TimeSpan)

        Dim StartTime As Date = Date.Now

        Try
            For i As Integer = 1 To Count
                Dim FileName As String = "Alphabet" & i
                Dim FullName As String = Path.Combine(
                    Path.GetDirectoryName(
                    Application.ResourceAssembly.Location), FileName)
                Await Task.Run(
                    Sub()
                        Dim r As Random = New Random()
                        Dim sw As StreamWriter =
                            New StreamWriter(FullName)
                        Dim s As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
                        For j As Integer = 1 To 104857600
                            sw.Write(s.Chars(r.Next(s.Length)))
                            If j Mod 1048576 = 0 Then
                                progress.Report(FileName & "を作成中 " &
                                    j \ 1048576 & "%")
                                If MyTokenSource IsNot Nothing Then
                                    If MyTokenSource.Token.IsCancellationRequested Then
                                        sw.Close()
                                        MyTokenSource.Token.ThrowIfCancellationRequested()
                                    End If
                                End If
                            End If
                        Next
                        sw.Close()
                    End Sub, MyTokenSource.Token)
            Next

        Catch ex As OperationCanceledException
            Return StartTime - Date.Now
        End Try
        Return Date.Now - StartTime

    End Function

    Private Sub CancelButton_Click(sender As Object, e As RoutedEventArgs) Handles CancelButton.Click

        If MyTokenSource IsNot Nothing Then
            MyTokenSource.Cancel()
        End If

    End Sub
End Class
