﻿Class MainWindow 

    Private IsPressed As Boolean
    Private OldAngle As Double
    Private OldRotate As Double

    Private Sub ValveImage_MouseMove(sender As Object, e As MouseEventArgs) Handles ValveImage.MouseMove

        If IsPressed Then
            Dim p As Point = e.GetPosition(ValveStackPanel)
            Dim NewAngle As Double = GetAngle(p) - OldAngle
            DirectCast(ValveImage.RenderTransform, 
                RotateTransform).Angle() = OldRotate + NewAngle
        End If

    End Sub

    Private Sub ValveImage_MouseLeftButtonDown(sender As Object, e As MouseButtonEventArgs) Handles ValveImage.MouseLeftButtonDown

        Dim p As Point = e.GetPosition(ValveStackPanel)
        IsPressed = True
        OldAngle = GetAngle(p)
        OldRotate =
            DirectCast(ValveImage.RenderTransform, 
            RotateTransform).Angle
        Mouse.Capture(sender)
        ValveImage.Cursor = Cursors.Hand

    End Sub

    Private Sub ValveImage_MouseLeftButtonUp(sender As Object, e As MouseButtonEventArgs) Handles ValveImage.MouseLeftButtonUp

        Mouse.Capture(Nothing)
        IsPressed = False
        ValveImage.Cursor = Nothing

    End Sub

    Private Function GetAngle(p As Point) As Double

        Dim CenterX As Double = ValveImage.ActualWidth / 2
        Dim CenterY As Double = ValveImage.ActualHeight / 2
        Dim dx = p.X - CenterX
        Dim dy = p.Y - CenterY
        Dim ImageAngle As Double = Math.Atan2(dy, dx)
        Return ImageAngle * 180 / Math.PI

    End Function
End Class
