﻿Class MainWindow 

    Sub DrawGraph()

        Const OuterRadius As Double = 75
        Const InnerRadius As Double = 20

        Dim CenterX As Double = GraphCanvas.ActualWidth / 2
        Dim CenterY As Double = GraphCanvas.ActualHeight / 2
        Dim NumberList As List(Of Integer) = New List(Of Integer)()
        For i As Integer = 0 To NumberListBox.Items.Count - 1
            NumberList.Add(
                CType(NumberListBox.Items(i), ListBoxItem).Content)
        Next
        Dim FillBrushes As Brush() = New Brush() {
            Brushes.Red, Brushes.Orange, Brushes.Yellow,
            Brushes.LightGreen, Brushes.Lime,
            Brushes.LightSeaGreen, Brushes.LightCoral}
        Dim rx As Double = 3 / 2 * Math.PI
        Dim pt = Function(dr As Double, rr As Integer) As Point
                     Dim x As Double = Math.Cos(dr) * rr + CenterX
                     Dim y As Double = Math.Sin(dr) * rr + CenterY
                     Return New Point(x, y)
                 End Function

        Dim Total As Integer = 0
        For Each i As Integer In NumberList
            Total += i
        Next
        GraphCanvas.Children.Clear()
        For i As Integer = 0 To NumberList.Count - 1
            Dim DrawSweep As Double =
                NumberList(i) / Total * 2 * Math.PI
            Dim Pos As Point = pt(rx, OuterRadius)
            Dim Pis As Point = pt(rx, InnerRadius)
            Dim Poe As Point = pt(rx + DrawSweep, OuterRadius)
            Dim Pie As Point = pt(rx + DrawSweep, InnerRadius)
            rx += DrawSweep
            Dim Figure As PathFigure = New PathFigure() With
                                       {.StartPoint = Pos}

            Figure.Segments.Add(
                New ArcSegment(Poe,
                               New Size(OuterRadius, OuterRadius), 0,
                               DrawSweep > Math.PI,
                               SweepDirection.Clockwise, True))
            Figure.Segments.Add(New LineSegment(Pie, True))
            Figure.Segments.Add(
                New ArcSegment(Pis,
                               New Size(InnerRadius, InnerRadius), 0,
                               DrawSweep > Math.PI,
                               SweepDirection.Counterclockwise,
                               True))
            Dim MyGeo As PathGeometry = New PathGeometry()
            MyGeo.Figures.Add(Figure)
            Dim MyPath As Path = New Path() With {.Data = MyGeo}
            MyPath.Fill = FillBrushes(i)
            GraphCanvas.Children.Add(MyPath)
        Next

    End Sub

    Private Sub AddButton_Click(sender As Object, e As RoutedEventArgs) Handles AddButton.Click

        Dim Number As Integer
        If NumberListBox.Items.Count > 6 Then
            MessageBox.Show("数値が多すぎます", Me.Title,
                MessageBoxButton.OK, MessageBoxImage.Error)
        ElseIf Integer.TryParse(NumberTextBox.Text, Number) Then
            Dim Item As ListBoxItem = New ListBoxItem() With
            {.Content = NumberTextBox.Text}
            NumberListBox.Items.Add(Item)
        Else
            MessageBox.Show("整数を入力してください", Me.Title,
                MessageBoxButton.OK, MessageBoxImage.Error)
        End If

    End Sub

    Private Sub DelButton_Click(sender As Object, e As RoutedEventArgs) Handles DelButton.Click

        If NumberListBox.SelectedItem IsNot Nothing Then
            NumberListBox.Items.Remove(NumberListBox.SelectedItem)
        End If

    End Sub

    Private Sub GoButton_Click(sender As Object, e As RoutedEventArgs) Handles GoButton.Click
        DrawGraph()
    End Sub
End Class
