﻿Imports System.Windows.Media.Animation
Class MainWindow

    Dim SlotStoryBoard As Storyboard
    Dim ImageIndex As Integer = 0
    Dim IsMoving As Boolean
    Dim IsStopRequested As Boolean

    Private Sub Storyboard_Completed(sender As Object, e As EventArgs)

        Dim MyStoryBoard = DirectCast(sender.TimeLine, Storyboard)
        ImageIndex = IIf(ImageIndex < 2, 6, ImageIndex - 1)
        SetImage()

        If Not IsStopRequested Then
            MyStoryBoard.Begin()
        Else
            IsStopRequested = False
            IsMoving = False
        End If

    End Sub

    Sub SetImage()

        Dim DisplayIndex As Integer = ImageIndex
        For i As Integer = 0 To 3
            Dim ig As Image =
                DirectCast(SlotStackPanel.Children(i), Image)
            ig.Source = New BitmapImage(
                New Uri("slot" & DisplayIndex & ".png",
                        UriKind.Relative))
            DisplayIndex = IIf(DisplayIndex > 5, 1, DisplayIndex + 1)
        Next

    End Sub

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        Dim MyAnimation = New DoubleAnimation(-48, 0,
                                              New Duration(New TimeSpan(0, 0, 0, 0, 120)),
                                              FillBehavior.Stop)
        SlotStoryBoard = New Storyboard()
        Storyboard.SetTarget(MyAnimation, SlotStackPanel)
        Storyboard.SetTargetProperty(
            MyAnimation, New PropertyPath("(Canvas.Top)", Nothing))
        SlotStoryBoard.Children.Add(MyAnimation)
        AddHandler SlotStoryBoard.Completed,
            AddressOf Storyboard_Completed

    End Sub

    Private Sub StartButton_Click(sender As Object, e As RoutedEventArgs) Handles StartButton.Click

        If Not IsMoving Then
            IsMoving = True
            SlotStoryBoard.Begin()
        End If

    End Sub

    Private Sub StopButton_Click(sender As Object, e As RoutedEventArgs) Handles StopButton.Click

        If IsMoving Then
            IsStopRequested = True
        End If

    End Sub
End Class
